var websitexp = new function() {
	var self = this;
	var prefService = null;		

	var DEBUG = false;

	this.PREFS_BRANCH = "";

	var log = function(logInfo) {
		if (DEBUG) { console.log(logInfo); }
	};

	// consts
	this.ADDON_ID 		= "{a2bfe612-4cf5-48ea-907c-f3fb25bc9d6b}";
	this.NAV_BAR 		= "nav-bar";
	this.BUTTON_ID 		= "websitexp_show_list_toolbar_button";
	this.BUTTON_LABEL 	= "Website Xplorer";

	// fields
	this.products = new Array();

	this.renderHistoryList = function() {
		try {
            window.frames["websitexpIfr"].location.reload();
		} 
		catch(ex) { log(ex); return null; }
	};
    
    this.currentURL = function() { };

	this.isToolbarButtonInstalled = function() {
		try {
			var isButtonInstalled = prefService.getBoolPref(this.ADDON_ID + ".toolbarButtonInstalled");
			if (isButtonInstalled) { return true; }
			return false;
		} catch(ex) { return false; }
	};

	this.setToolbarButtonInstalledPref = function(value) {
		prefService.setBoolPref(this.ADDON_ID + ".toolbarButtonInstalled", value);
	};
	
    this.init = function() {
		prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(this.PREFS_BRANCH);    	

    	if (!self.isToolbarButtonInstalled()) {
    		self.setToolbarButtonInstalledPref(true);
    		self.addToolbarButton();
    	}
    };

    this.addToolbarButton = function() {
    	try {
    	    var toolbarButton = document.getElementById(this.BUTTON_ID);    	    
    	    if (toolbarButton) { return false; }	// if a button already exists, do nothing...
    	    
    	    var toolbar = document.getElementById(this.NAV_BAR);
    	    toolbarButton = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "xul:toolbarbutton");
    	    toolbarButton.setAttribute('id', this.BUTTON_ID);
    	    toolbarButton.setAttribute('label', this.BUTTON_LABEL);
    	    toolbarButton.setAttribute('tooltiptext', this.BUTTON_LABEL);
    	    toolbarButton.setAttribute('title', this.BUTTON_LABEL);
    	    toolbarButton.setAttribute('class', 'toolbarbutton-1 chromeclass-toolbar-additional');    	   
    	    toolbarButton.setAttribute('onclick', this.renderHistoryList());
    	    toolbar.appendChild(toolbarButton);	
    	    toolbar.insertItem(this.BUTTON_ID, null, null, false);
    	    toolbar.setAttribute("currentset", toolbar.currentSet);
    	    document.persist(toolbar.id, "currentset");
    	
    	    return true;
    	} catch(ex) { log(ex); return false; }
    };

    this.clearPopup = function() {
		document.getElementById("websitexp-dropdown").removeChild(document.getElementById("websitexpIfr"))
		var ifr = document.createElement("iframe");
		ifr.setAttribute('src', 'chrome://websitexp/content/popup.html');
		ifr.style.width = "290px";
		ifr.style.height = "500px";
		ifr.id = "websitexpIfr";
		document.getElementById("websitexp-dropdown").appendChild(ifr);
	};
};

window.addEventListener("load", function() { websitexp.init(); }, false);