var sitecounselor_pop_up = new function() {
	var self = this;
	var prefService = null;
	
	var DEBUG = false;	

	var log = function(logInfo) {
		if (DEBUG) { console.log(logInfo); }
	};

	// consts
	this.PRIVACY_LINK 	= "http://addons-privacy.com/";
	this.PREFS_BRANCH 	= "";

	this.url =  '';
	this.AddonInfo = null;

	this.init = function() {
		this.loadModules();
		this.setDebug();
		prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(this.PREFS_BRANCH);
		var newUrl = this.getCurrentURL();
		if (this.url == newUrl) { return; }
		this.url = newUrl;
		this.getSimiliarSites(this.url);
	};

	this.loadModules = function() {
		Components.utils.import("resource://sitecounselor/FileCacher.js", this);
		Components.utils.import("resource://sitecounselor/AddonInfo.js", this);
	};	

	this.setDebug = function() {
		if (DEBUG && this.AddonInfo && this.AddonInfo.debug === false) { DEBUG = false; }
	};

	this.getSimiliarSites = function(url) {
		var src = "";
		try { src = prefService.getCharPref(this.AddonInfo.id + ".src"); }
		catch(e) {}
		if (src == "") {
			try{ src = prefService.getCharPref(this.AddonInfo.id + ".com.src"); }
			catch(e){}
		}

		var btnsrc = src + "1";
		if (src == "99992") {
			btnsrc = "99991";
		}
			
		if (this.get_hostname(url) == "") { return; }

		var server = "";
		try { server = prefService.getCharPref(this.AddonInfo.id + ".server"); }
		catch(e) {}
		
		var similarQuery = server+"/related?s="+btnsrc+"&md=18&q=" + encodeURIComponent(this.get_hostname(url)) ; 
		$.ajax({
			type: "GET",
			url: similarQuery,
			dataType : 'xml',
			success: function (result) {
				self.processSimiliarXML(result);
			},
			error: function () { }
		})
	};

	this.processSimiliarXML = function(xml) {
		var cnt = 0;
		try {
			var status = $(xml).find("status").text();
			if (status == 0) {
				// Enumerate similiar sites and create a 'button' for them.
				$(xml).find("site").each(function () {
					var name = $(this).find("title").text();
					var url = $(this).find("url").text();
					var icon = $(this).find("icon").text();
					var image = $(this).find("image").text();
					var description = $(this).find("description").text();
					var title = $(this).find("title").text();
					url = 'http://' + url;
					self.addSiteButton(name, url, icon, image, description);
					cnt = cnt+1;
				});
				this.processSimiliar();  
			}
			else if ((status != 0) || (cnt == 0)) {
				try {
					var d = $("<div />");
					var host_span = $("<span />").addClass("site").append(this.get_hostname(this.getCurrentURL()));
					var unable_msg = $("<p />").addClass("no-results-para").append("Unable to locate results for ").append(host_span);
					var try_later = $("<p />").addClass("no-results-para").append("Please try again later");
					var img_item = $("<img />",{src:'chrome://sitecounselor/skin/ss-large.png'}).addClass("no-results-logo");
					var img_link = $("<a />").append(img_item);
					var error_img = $("<p />",{id:'error-img'}).addClass("no-results-para").append(img_link).click(function(){   var cur_url = "http://www.sitecounselor.com/";    self.loadUrlInNewTab(cur_url);   });;
					d.addClass("container").css("background-color","white").css("height","100%").append(unable_msg).append(try_later).append(error_img);
					$('.InnerContainer').append(d); 				
				} catch (e) {}
			}
		}
		catch (e) {}
	};

	this.addSiteButton = function(name, url, icon, image, description) { 
		var hostUrl = this.getHost(url);
		var button = this.createButton(name, hostUrl, icon , image, description);
		$('.InnerContainer').append(button);
		return button;
	};

	this.createButton = function(name, url, icon , image, description) {       
		if(name == null)         name = '';
		if(url == null)          url = '';
		if(icon == null)         icon = '';
		if(image == null)        image = '';
		if(description == null)  description = '';      

		var img_ThumbRT = document.createElement("img");
		img_ThumbRT.className = "ThumbRT";            
		img_ThumbRT.setAttribute('src', icon);
		img_ThumbRT.setAttribute('title', description);
		img_ThumbRT.setAttribute('alt', name);

		var imgWrapper = document.createElement("div");
		imgWrapper.className = "ThumbRI";
		imgWrapper.appendChild(img_ThumbRT);       

		var txtWrapper = document.createElement("div");
		txtWrapper.className = "TextWrapper";
		//txtWrapper.textContent = description;

		var siteName = document.createElement("div");
		siteName.className = "SiteName";
		siteName.textContent = name;
		txtWrapper.appendChild(siteName);

		var siteDesc = document.createElement("div");
		siteDesc.className = "SiteDesc";
		siteDesc.textContent = description;
		txtWrapper.appendChild(siteDesc);

		var siteLink = document.createElement("div");
		siteLink.className = "SiteLink";
		siteLink.textContent = url;
		txtWrapper.appendChild(siteLink);
		
		var div_ThumbRIWrapper = document.createElement("div");
		div_ThumbRIWrapper.className = "ThumbRIWrapper";
		div_ThumbRIWrapper.setAttribute('title', description);
		div_ThumbRIWrapper.appendChild(imgWrapper);    
		div_ThumbRIWrapper.appendChild(txtWrapper);
		
		div_ThumbRIWrapper.onclick = function() {
			self.loadUrlInNewTab("http://"+url);
		}
		
		return div_ThumbRIWrapper;                
	};

	this.processSimiliar = function() {
		$('#privacy_text').click(function() {                 
			var cur_url = this.PRIVACY_LINK;
			this.loadUrlInNewTab(cur_url);
		});
	};

	this.getHost = function (url) {
		var anchor = document.createElement('a');
		anchor.href = url;
		return anchor.hostname;
	};

	this.get_hostname = function(url) {
		var ret = '';
		try {
			ret = url.match(/:\/\/(.[^/]+)/)[1];
		}
		catch(e) { ret = ''; }

		return ret;
	};

	this.setBadge = function(text) {
		chrome.browserAction.setBadgeText({ "text": text.toString() });
	};

	this.getCurrentURL = function() {
		var currentWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser");
		var currBrowser = currentWindow.getBrowser();
		var currURL = currBrowser.currentURI.spec;
		return currURL;
	};

	this.loadUrlInNewTab = function(uri) {
		var currentWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser");
		var currBrowser = currentWindow.getBrowser();
		currBrowser.selectedTab = currBrowser.addTab( uri );    
	};

	this.init();
};