var EXPORTED_SYMBOLS = ["TimePassed"];

var win = null;
var log = function(text) {
	if (win && DEBUG) { win.console.log(text); }
};

var DEBUG = true;

var TimePassed = function() {
	var self = this;

	this.PrefMan = null;
	this.AddonInfo = null;
	this.installtime = null;	// currently represented as seconds

	this.TIME_TYPE = {
		SECONDS : 1,
		MINUTES : 2,
		HOURS	: 3,
		DAYS 	: 4
	};

	this.init = function() {
		this.loadModules();
		this.setDebug();
		this.setWindow();
		this.installtime = this.PrefMan.getPref("installtime");
		if (!this.installtime) { 
			this.installtime = new Date() / 1000;
			this.PrefMan.setPref("installtime", this.installtime); 
		}
	};

	this.hasTimePassed = function(time, timeType) {
		if (!this.installtime) { return false; }
		timeType = timeType || this.TIME_TYPE.SECONDS;
		timePassed = new Date() / 1000 - this.installtime;

		if (timeType === this.TIME_TYPE.MINUTES) {
			timePassed = timePassed / 60;
		} else if (timeType === this.TIME_TYPE.HOURS) {
			timePassed = timePassed / 60 / 60;
		} else if (timeType === this.TIME_TYPE.DAYS) {
			timePassed = timePassed / 60 / 60 / 24;
		}
		log("time passed:");
		log(timePassed);
		return timePassed >= time;

		return false;
	};

	this.setWindow = function() {
		var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
			.getService(Components.interfaces.nsIWindowMediator);
		win = wm.getMostRecentWindow(null);
	};

	this.loadModules = function() {
		Components.utils.import("resource://sitecounselor/PrefMan.js", this);
		Components.utils.import("resource://sitecounselor/AddonInfo.js", this);
	};	

	this.setDebug = function() {
		if (DEBUG && this.AddonInfo && this.AddonInfo.debug === false) { DEBUG = false; }
	};

	this.init();
};